import os

class MapNotSquareException(Exception):
    """
    Matrix used is not a Square and cannot be interpretted as a piece
    """

class PieceNotSquareException(Exception):
    """
    Matrix used is not a Square and cannot be interpretted as a piece
    """

class SaveParser:
    """
    Parser for the game file
    """
    def __init__(self):
        self.filename = filename
        self.map_shape = [[0]]
        self.pieces = list()

    def define_map(self, map_shape):
        size = len(map_shape)
        for row in map_shape:
            if size != len(row):
                raise MapNotSquareException
        self.map_shape = map_shape

    def add_piece(self, piece_shape):
        size = len(piece_shape)
        for row in piece_shape:
            if size != len(row):
                raise PieceNotSquareException
        self.pieces.append(piece_shape)

    def __str__(self):
        return str(self.map_shape)

    def shape_to_bytes(self, shape_matrix):
        shape_list = [b for r in shape_matrix for b in r]
        byte_ammount = len(shape_list) // 8 + 1
        tray = 0
        for i in shape_list:
            tray = (tray << 1) | i
        return tray.to_bytes(byte_ammount, 'big')


    def load(self):
        """
        load the file and prepare to parse informations
        """

    def save(self, filename):
        """
        save parsed info to the file
        """
        save_data = b''
        save_data += b'SMS'
        save_data += len(self.map_shape).to_bytes(1, 'big')
        save_data += self.shape_to_bytes(self.map_shape)
        save_data += len(self.pieces).to_bytes(1, 'big')
        for piece in self.pieces:
            save_data +=len(piece).to_bytes(1, 'big')
            save_data += self.shape_to_bytes(piece)
        save_data += b'SME'
        with open(filename, mode='bw') as file:
            file.write(save_data)

def cls():
    'clear the screen'
    for _ in range(os.get_terminal_size()[1]):
        print()

def menu():
    """draw a simple menu to test the SaveParser class"""

    P = SaveParser()

    print("1) define terrain")
    print("2) add a piece")
    print("3) show data")
    print("4) save data")
    print("5) load data")
    item = input("Select an option :")
    cls()
    match item:
        case 1:
            pass
        case 2:
            pass
        case 3:
            pass
        case 4:
            filename = input('enter the file name (default: default.smap):')
            filename = filename if filename else "default.smap"
            P.save(filename)
        case 5:
            filename = input('enter the file name (default: default.smap):')
            filename = filename if filename else "default.smap"
            P.load(filename)
if __name__ == "__main__":
    cls()
    # p = SaveParser('test.smap')
    # p.define_map([[1,0,1],[1,1,1], [1,0,0]])
    # p.add_piece([[0, 1],[0, 1]])
    # p.save()
    # print(p.shape_to_bytes([[1,0,1],[1,1,1], [1,0,0]]))
